#include <stdio.h>
#include <stdlib.h>
#include <iostream>
using namespace std;

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0

void eratos( short *arr, ulong size ) {
   ulong i, j;
   for( i = 2; i < size; i++ )                     // цикл по всему массиву от первого простого числа "2"
      if( 1 == arr[ i ] ) 
         for( j = i + i; j < size; j += i )        // вычеркивание всех чисел кратных i 
           arr[ j ] = 0;
}

int main( int argc, char **argv ) {
   long n;
   while( 1 ) {
      cout << "граничное число: ";
      cin >> n;
      short *a = new short[ n + 1 ];               // создаём массив
      a[ 0 ] = a[ 1 ] = 0;                         // вычёркиваем "0" и "1"
      for( ulong k = 2; k < n; k++ ) a[ k ] = 1;   // остальные размечаем как простые
      eratos( a, n );
      ulong j = 0;
      for( ulong k = 0; k < n; k++ )               // подсчёт: что получилось?
         j += ( a[ k ] != 0 ? 1 : 0 );
      cout << j << " простых чисел:" << endl;
      const int INLINE = 10;
      for( ulong k = 0, j = 0; k < n; k++ )
         if( 1 == a[ k ] ) {
            j++;
            printf( "%5lu%s", k, ( 0 == j % INLINE ? "\n" : "" ) );
         }
      if( j % INLINE != 0 ) printf( "\n" );
      delete [] a;
   }
   return 0;
}
